* Window drawing routines		v0.00   1987  J.R.Oakley  QJUMP
*					v0.01	updated by T.Tebby after W.Lenerz
* 2020-08-19  v0.02   added call to indexes drawing for menu (AH)
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_keys_qdos_ioa'
	include 'dev8_keys_qdos_io'
	include 'dev8_mac_assert'
	include 'dev8_keys_wwork'
	include 'dev8_keys_wstatus'
	include 'dev8_keys_wman'
	include 'dev1_asm_qptr_keys'
*
	xref	ber_mode
	xref	bem_achp
	xref	bem_rchp
	xref	bem_chpn
	xref	bem_ciar
	xref	bem_gsiz
	xref	bed_clfl
	xref	bed_ccdf
	xref	bed_rclf
	xref	bed_rcaf
	xref	bed_cafl
	xref	ut_getch
*
	xdef	bed_gwmv
	xdef	bed_rdli
	xdef	bed_rdaw
*
	xdef	be_drpps
	xdef	be_drpld
	xdef	be_drldw
	xdef	be_dridw
	xdef	be_drmdw
	xdef	be_druns
	xdef	be_drswd
	xdef	be_drlwd
	xdef	be_driwd
*
*	Get the window manager vector
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	A0	channel ID			preserved
*	A2					window manager vector
*
gwmvreg reg	d1/d3/a1
bed_gwmv
	movem.l gwmvreg,-(sp)
	moveq	#-1,d3
	moveq	#iop.pinf,d0
	trap	#3
	move.l	a1,a2
	tst.l	d0
	movem.l (sp)+,gwmvreg
	rts
*
bed_gprm
	moveq	#2,d7			; more than two parameters?
	jsr	bem_chpn(pc)
	bge	bed_exbp		; no, not enough then
	move.l	a5,d7			; keep pointer to last parameter
	lea	8*3(a3),a5		; and get three...
	move.w	ca.gtlin,a2		; ...long integers
	jsr	(a2)
	bne	bed_exit		; ...oops
	move.l	a5,a3			; point after just-got parameters
	move.l	d7,a5			; and to end of them
*
	move.l	0(a6,a1.l),a4		; point to window definition
	move.w	6(a6,a1.l),d5		; get X...
	swap	d5
	move.w	10(a6,a1.l),d5		; ...and Y origin
*
	move.w	ww_nlitm(a4),d7 ; space for loose flags
	moveq	#ws_litem,d1		; plus header
	add.w	d7,d1
	jsr	bem_achp(pc)		; get status area
	bne.s	bed_exit		; no room
	move.l	a0,ww_wstat(a4) ; fill in
	move.l	a4,ws_work(a0)		; and reciprocal pointer
*
	jsr	ber_mode(pc)		; find out mode
	move.w	#$108,d0		; allowable forms are like this
	and.b	d1,d0			; get mode
	lsr.b	#3,d0			; shift it to allowed form
	move.w	d0,ws_wmode(a0) ; fill it in
*

	tst.w	d7
	beq.s	bed_capf		; no loose items, skip this bit
	jsr	bem_ciar(pc)		; check that we've got an integer array
	bne.s	bed_capf		; we haven't, don't copy flags
	jsr	bed_clfl(pc)		; copy all the loose flags
	bne.s	bed_exit		; ...oops
	addq.l	#8,a3			; one array gone
*
*	Now we can copy the application menu flags
*
bed_capf
	move.l	ww_pappl(a4),a2 ; point to application window list
	move.w	ww_nappl(a4),d7 ; and number of them
	move.l	a4,d4			; keep menu address safe
	bra.s	bed_appe
bed_appw
	move.l	(a2)+,a4		; next sub-window
	tst.l	wwa_draw(a4)		; does it need flags?
	beq.s	bed_appe		; nope
	cmp.l	a3,a5
	ble.s	bed_exbp		; no arrays left
	jsr	bem_ciar(pc)		; find array
	bne.s	bed_exit		; karangg!
	jsr	bed_cafl(pc)		; copy application flags
	bne.s	bed_exit		; ...oops
	addq.l	#8,a3
*
	move.l	wwa_part(a4),a1 ; x control is here
	move.w	wwa_nxsc(a4),d6 ; is there one?
	beq.s	bes_cysc		; no, try y
	jsr	bed_ccdf(pc)		; yes, copy it
	bne.s	bed_exit
	addq.l	#8,a3			; and point to next parameter
*
bes_cysc
	move.l	wwa_part+wwa.clen(a4),a1
	move.w	wwa_nysc(a4),d6 ; y control?
	beq.s	bed_appe		; no, do next window
	jsr	bed_ccdf(pc)		; yes, copy
	bne.s	bed_exit
	addq.l	#8,a3
bed_appe
	dbra	d7,bed_appw
*
bed_exok
	move.l	d4,a4			; point to working definition
	move.l	d5,d1			; restore initial position
	moveq	#0,d0
bed_exit
	tst.l	d0
	rts
bed_exbp
	moveq	#err.ipar,d0
	bra.s	bed_exit
*
*	Position a primary window
*
be_drpps
	jsr	ut_getch(pc)		; get the channel ID
	bne	bed_exit		; ...oops
	move.l	a4,-(sp)
	bsr	bed_gprm		; get the parameters
	move.l	(sp)+,a0		; restore and...
	bne	bed_exit		; (oops)
	move.l	a0,ww_chid(a4)		; ...fill in channel ID
*
	bsr	bed_gwmv		 ; get window manager vector
	move.l	ww_xorg(a4),ww_spar1(a4) ; copy origin
	jsr	wm.prpos(a2)		 ; position it
	bne.s	bep_exit
	jsr	wm.wdraw(a2)		; and draw it
bep_exit
	rts
*
*	Pull down a secondary window
*
be_drpld
	jsr	ut_getch(pc)		; get the channel ID
	bne	bed_exit		; ...oops
	move.l	a4,-(sp)
	bsr	bed_gprm		; get the parameters
	move.l	(sp)+,a0		; restore channel ID
	bne	bed_exit		; ...oops
*
	bsr	bed_gwmv		 ; get window manager vector
	move.l	ww_xorg(a4),ww_spar1(a4) ; copy origin
	jsr	wm.pulld(a2)		 ; pull the window down
	bne.s	bep_exit
	jsr	wm.wdraw(a2)		; and draw it
	rts
*
*	Re-draw loose menu items: the statuses are copied afresh from a flag
*	array.	If any status flag had its change bit set then the re-draw
*	is selective, otherwise all loose items are re-drawn.
*
be_drldw
	moveq	#2,d7			; exactly two parameters
	jsr	bem_chpn(pc)		; check them
	bne	bep_exit		; not two
	lea	8(a3),a5		; get just one
	move.w	ca.gtlin,a2
	jsr	(a2)
	bne	bep_exit		; bum parameter
	move.l	0(a6,a1.l),a4		; point to working definition
	move.l	a5,a3			; second parameter
	moveq	#0,d3			; allow draw all
*
*	Entry point to re-copy flags and draw loose items: used from RD_PTR
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	D1/D3					smashed
*	A0-A2					smashed
*	A3	pointer to lflag array in NT	preserved
*	A4	working definition		preserved
*
bed_rdli
	jsr	bem_gsiz(pc)		; must be an integer array, get size
	bne	bed_exit
	cmp.w	ww_nlitm(a4),d1 ; must have this many elements
	bne	bed_exbp
	tst.w	d1			; none at all?
	beq	bed_exit		; not much to do then
*
	jsr	bed_rclf(pc)		; copy flags
	bne	bed_exit
	move.l	ww_chid(a4),a0
	bsr	bed_gwmv		; get manager vector
	bne	bed_exit
	neg.b	d1			; 1 if change bits set, else 0...
	or.b	d1,d3			; ...gives selective or all flag value
	beq.s	bed_fldr		; all, must do the draw
	tst.b	d1			; selective, anything to do?
	beq.s	bed_skld		; no, skip draw
bed_fldr
	jsr	wm.ldraw(a2)
*
bed_skld
	move.l	ww_wstat(a4),a1 ; point to status area
	lea	ws_litem(a1),a1 ; and to loose item flags
	move.w	ww_nlitm(a4),d1 ; this many
	bra.s	bed_clce
bed_clcl
	bclr	#wsi..chg,(a1)+
bed_clce
	dbra	d1,bed_clcl
	bra	bed_exit
*
bep_exor
	moveq	#err.orng,d0
	rts
*
*	Re-draw an application sub-window: the statuses are copied from a flag
*	array.	If any status flag had its change bit set then the re-draw
*	is selective, otherwise all items are re-drawn.
*
be_drmdw
	moveq	#2,d7			; we need more than two parameters
	jsr	bem_chpn(pc)		; check them
	bge	bed_exbp		; miserable failure
	move.l	a5,d7
	lea	2*8(a3),a5		; get first two
	move.w	ca.gtlin,a2
	jsr	(a2)
	bne	bep_exit		; bum parameter
	move.l	0(a6,a1.l),a4		; point to working definition
	move.l	4(a6,a1.l),d1		; sub-window to re-draw
	cmp.w	ww_nappl(a4),d1 ; in range?
	bhi.s	bep_exor		; nope
	add.w	d1,d1
	add.w	d1,d1
	move.l	ww_pappl(a4),a2 ; the sub-window list is here
	move.l	0(a2,d1.w),a2		; point to the sub-window
	move.l	a5,a3			; second parameter
	moveq	#0,d3			; allow draw all
	move.l	d7,a5
*
*	Entry point to re-copy flags and draw application sub-window:
*	used from RD_PTR.  If there are control sections arrays describing
*	them should also be supplied.
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	D1					smashed
*	D3	0 for all, -1 for selective	smashed
*	A0					smashed
*	A1					preserved
*	A2	pointer to sub-window		preserved
*	A3	pointer to aflag array in NT	updated
*	A4	working definition		preserved
*
ardreg	reg	a1-a2
bed_rdaw
	movem.l ardreg,-(sp)
	tst.l	wwa_draw(a2)		; can we set flags for this window?
	beq	bea_exbp		; no, wally
*
*	Copy flags/control info from arrays
*
	jsr	bem_ciar(pc)		; must be an integer array, get size
	bne.s	bea_exit
	exg	a2,a4
	jsr	bed_rcaf(pc)		; copy flags
	exg	a2,a4
	bne.s	bea_exit		; flags failed
	addq.l	#8,a3			; next parameter
	move.b	d1,d7			; keep 1 if change bits set, else 0
*
	move.l	wwa_part(a2),a1 ; x control is here
	move.w	wwa_nxsc(a2),d6 ; is there one?
	beq.s	bea_cysc		; no, try y
	cmp.l	a3,a5
	ble.s	bea_exbp		; yes, but no array: bother
	jsr	bed_ccdf(pc)		; copy it
	or.b	d1,d7			; keep change flag
	addq.l	#8,a3			; and point to next parameter
*
bea_cysc
	move.l	wwa_part+wwa.clen(a2),a1
	move.w	wwa_nysc(a2),d6 ; y control?
	beq.s	bea_rdrw		; no, re-draw now
	cmp.l	a3,a5
	ble.s	bea_exbp		; yes, but no array
	jsr	bed_ccdf(pc)		; yes, copy
	or.b	d1,d7			; keep change flag
	addq.l	#8,a3
*
*	Now we can re-draw: D7 is zero if nothing has changed, -1 if
*	a control block has changed, or +1 if statuses have changed.
*	D3 is zero if we may do a full re-draw.
*
bea_rdrw
	move.l	a3,-(sp)		; save current parameter
	move.l	ww_chid(a4),a0		; get channel ID
	move.l	a2,a3			; and sub-window pointer
	bsr	bed_gwmv		; and manager vector
	bne.s	bea_exrd
*
	move.b	d3,d1			; keep permitted re-draw safe
	moveq	#0,d3			; assume force all
	tst.b	d7			; control change?
	bmi.s	bea_fmdr		; yes, re-draw the lot
	beq.s	bea_chka		; no, but may still draw all
	moveq	#-1,d3			; partial re-draw
	bra.s	bea_fmdr		; do it
bea_chka
	tst.b	d1			; allowed a full re-draw?
	bne.s	bea_skdr		; no, skip it
bea_fmdr
        jsr     wm.index(a2)		; re-draw indexes (AH)
	jsr	wm.mdraw(a2)		; re-draw menu
	bne.s	bea_exrd
*
bea_skdr
	move.l	wwa_mstt(a3),a1 ; point to status area
	move.w	wwa_ncol(a3),d1 ; this many...
	mulu	wwa_nrow(a3),d1 ; ...items
	bra.s	bed_cace
bed_cacl
	bclr	#wsi..chg,(a1)+
bed_cace
	dbra	d1,bed_cacl
bea_exrd
	move.l	(sp)+,a3		; restore current parameter
*
bea_exit
	movem.l (sp)+,ardreg
	bra	bed_exit
bea_exbp
	moveq	#err.ipar,d0
	bra.s	bea_exit
*
*	Re-draw a (set of) information sub-windows
*
*	DR_IDRW menu,iwbits
*
be_dridw
	move.w	ca.gtlin,a2
	jsr	(a2)			; get parameters
	bne	bed_exit
	subq.w	#2,d3			; two of them
	bne	bed_exbp
	move.l	0(a6,a1.l),a4		; get working definition
	move.l	4(a6,a1.l),d3		; and the windows to re-draw
	move.l	ww_chid(a4),a0
	bsr	bed_gwmv		; get vector
	bne	bed_exit		; ...oops
	jmp	wm.idraw(a2)		; and re-draw
*
*	Unset a window definition: this calls the window manager's UNSET
*	routine, and additionally de-processes the working definition
*	so that all pointers are relative.
*
be_druns
	move.w	ca.gtlin,a2
	jsr	(a2)			; get pointer to definition
	bne	bed_exit
	subq.w	#1,d3			; exactly one
	bne	bed_exbp
	move.l	0(a6,a1.l),a4		; point to definition
	bsr.s	bedr_rechp		; and get rid of (menu) status areas

	move.l	ww_chid(a4),a0		; using the window itself...
	bsr	bed_gwmv		; ...get the window manager vector
	bne	bed_exit
	jsr	wm.unset(a2)		 ; unset the definition
	bne	bed_exit
	move.l	ww_spar1(a4),ww_xorg(a4) ; and restore origin
	tst.b	ww_pulld(a4)		; is it pull-down?
	beq	bed_exit		; no, finished
	move.l	ww_chid(a4),a0
	moveq	#ioa.clos,d0		; yes, close
	trap	#2
	bra	bed_exit

; contribution from W Lenerz

bedr_rechp
	move.w	ww_nappl(a4),d7 ; application sub windows
	beq.s	bedr_r_out
	subq.w	#1,d7			; dbra
	move.l	ww_pappl(a4),a5
bedr_loop
	move.l	(a5)+,d0
	beq.s	bedr_r_out		; Wolf says this is for security!
	move.l	d0,a1			; application sub-window def

     ; Here Wolf checks the number of control sections.
     ; This seems to assume that all menus require control.
     ; Since the bem_rechp routine does nothing if the address passed
     ; is not in SuperBASIC's linked list of common heap allocations,
     ; would it not be better just to assume that wwa_mstt always points
     ; to a working area associated with the sub-window. If this assumption
     ; is wrong, the location will either be unset (0) or it will not be
     ; pointing to an item in the common heap linked list.

	move.l	wwa_mstt(a1),a0 ; common heap allocation or rubbish
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;	 subq.l  #4,a0		; NO; THIS IS DONE IN	BEM_RCHP
	jsr	bem_rchp
	dbra	d7,bedr_loop

bedr_r_out
	move.l	ww_wstat(a4),a0

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;	 subq.l  #4,a0		 ; NO; THIS IS DONE IN	 BEM_RCHP
	jmp	bem_rchp

*
*
bed_swpm
	jsr	ut_getch(pc)		; get the window to set
	bne.s	bew_exit		; ...oops
	move.w	ca.gtlin,a2
	jsr	(a2)			; and some long integers
	bne.s	bew_exit
	subq.w	#2,d3
	bne.s	bew_exbp		; wrong number
	move.l	0(a6,a1.l),a0		; menu
	move.l	4(a6,a1.l),d1		; and sub-window number
	moveq	#0,d0
bew_exit
	rts
bew_exbp
	moveq	#err.ipar,d0
	bra.s	bew_exit
bew_exor
	moveq	#err.orng,d0
	bra.s	bew_exit
*
*	Set a channel to have the same area as a given sub-window
*
*	DR_SWDF [#ch,]menu,swnum%
*
be_drswd
	bsr	bed_swpm
	bne	bew_exit
	cmp.w	ww_nappl(a0),d1
	bhi	bew_exor		; off the end
	add.w	d1,d1
	add.w	d1,d1
	move.l	ww_pappl(a0),a3 ; sub-windows are here
	add.w	d1,a3			; this is the one...
	move.l	(a3),a3 	;...here
	exg	a0,a4
	bsr	bed_gwmv		; get vector
	bne	bed_exbp		; ...oops
	jsr	wm.swdef(a2)		; set definition
	tst.l	d0			; and ccr
	bra	bed_exit
*
*	Set a window to the area occupied by a loose item
*
*	DR_LWDF [#ch,]menu,item%
*
be_drlwd
	bsr	bed_swpm		; get parameters
	bne	bew_exit
	cmp.w	ww_nlitm(a0),d1 ; enough items?
	bhi	bew_exor		; no
	mulu	#wwl.elen,d1		; yes, this far in
	move.l	ww_plitm(a0),a2 ; point to items
	add.l	d1,a2			; and to the one we want
*
bew_srel
	assert	wwl_xsiz,wwi_xsiz
	assert	wwl_xorg,wwi_xorg
	move.l	wwl_xsiz(a2),0(a6,a1.l) ; set size
	move.l	wwl_xorg(a2),d1 ; the origin...
	add.l	ww_xorg(a0),d1		; ...is relative to the main window
	move.l	d1,4(a6,a1.l)		; fill it in
*
	move.l	a4,a0			; this is our window
	moveq	#0,d2			; no border
	moveq	#-1,d3			; sometime
	moveq	#iow.defw,d0		; define the window
	trap	#4
	trap	#3
	tst.l	d0
	bra	bew_exit
*
*	Set a window to the same area as an information sub-window
*
*	DR_IWDF [#ch,]menu,iwnum%
*
be_driwd
	bsr	bed_swpm		; get some parameters
	bne	bew_exit
	cmp.w	ww_ninfo(a0),d1 ; 'nuff winders?
	bhi	bew_exor		; no chance
	mulu	#wwi.elen,d1		; yes, this far in
	move.l	ww_pinfo(a0),a2 ; point to info window list
	add.l	d1,a2			; and to the one we want
	bra	bew_srel		; set it
*
	end
