* Routines to set mouse speed etc.	v0.00   Oct 1987  J.R.Oakley  QJUMP
*
*       These routines will always work instantly with Pointer
*       Interface v1.10+, but may have to wait for the window to
*       be unlocked in earlier versions.  MS_HOT only works with
*       v1.10+.
*
*       MS_SPD  [#ch,]acceleration[,wake_up]
*       MS_HOT  [#ch,]hot$
*
        section prog
*
        include 'dev8_keys_err'
        include 'dev8_keys_qdos_io'
        include 'dev8_mac_assert'
        include 'dev8_keys_con'
        include 'dev1_asm_qptr_keys'
*
        xref    ut_getch
*
        xdef    be_msspd
        xdef    be_mshot
*
bem_chk9
        cmp.w   #9,d1		; is d1 in 0..9 ?
        bhi.s   bec_exor		; no
        moveq   #0,d0
        rts
bec_exor
        moveq   #err.orng,d0
        rts
*
*       Set the mouse speed: the acceleration may be in the range 0-9,
*       as may the wake-up speed.
*
be_msspd
        jsr     ut_getch(pc)		; get us a channel ID
        bne.s   bem_exit		; whoops
        move.w  ca.gtlin,a2
        jsr     (a2)		; get some long integers
        bne.s   bem_exit		; whoops again
        subq.w  #1,d3		; just one?
        bmi.s   bem_exbp		; no, none: wally
        beq.s   bem_sacc		; yes, set acceleration
*
        addq.l  #7,a1		; wake-up speed is just a byte
        moveq   #0,d1
        move.b  0(a6,a1.l),d1 	; get it
        bsr.s   bem_chk9		; check it's in range
        bne.s   bem_exit		; it isn't
        moveq   #1,d2		; one byte
        moveq   #pt_wake,d1		; set wake-up speed
        bsr.s   bem_slnk		; do it
        bne.s   bem_exit		; eek
        subq.l  #7,a1		; skip back to acceleration
*
bem_sacc
        move.w  2(a6,a1.l),d1 	; get required acceleration
        bsr.s   bem_chk9		; be sure it's in range
        bne.s   bem_exit		; wrong
        moveq   #9,d2		; 0..9 becomes
        sub.w   d1,d2		; 9..0
        move.w  d2,2(a6,a1.l) 	; in the case of Y
        add.w   d2,d2		; and 18..0 by 2
        move.w  d2,0(a6,a1.l) 	; in the case of X
        assert  pt_xaccl,pt_yaccl-2
        moveq   #pt_xaccl,d1		; we want to change the x and y accels
ms.accl equ     4
        moveq   #ms.accl,d2		; that's four bytes
        bsr.s   bem_slnk		; set that
        bne.s   bem_exit		; wow
*
        addq.w  #1,0(a6,a1.l) 	; keyboard accel= 2*xaccl+1
        moveq   #2,d2		; two bytes
        moveq   #pt_kaccl,d1		; here
        bsr.s   bem_slnk
bem_exit
        rts
bem_exbp
        moveq   #err.ipar,d0
        bra.s   bem_exit
*
bem_exni
        moveq   #err.nimp,d0
        bra.s   bem_exit
*
bem_slnk
        move.l  a1,-(sp)
        move.l  a4,a0		; get channel ID
        moveq   #-1,d3		; infinite timeout
        moveq   #iop.slnk,d0		; set bytes in linkage block
        trap    #4			; this is SuperBASIC
        trap    #3
        move.l  (sp)+,a1
        tst.l   d0
        rts
*
*       Set key sequence resulting from pressing both mouse buttons.
*       This is zero (to unset it), one or two characters long, 
*       but may be set to ALT/something to get longer sequences if needed.
*
be_mshot
        jsr     ut_getch(pc)		; get a channel
        bne     bem_exit		; whoops
*
        move.l  a4,a0
        moveq   #-1,d3
        moveq   #iop.pinf,d0		; ensure the facility exists
        trap    #3
        tst.l   d0
        bne     bem_exit		; not even a pointer interface!
        and.l   #$ff00ffff,d1 	; mask out d.p. (country letter?)
        cmp.l   #'1'<<24+'10',d1	; at least 1x10?
        blt     bem_exni		; no, "not implemented"
*
        move.w  ca.gtstr,a2		; get string to set
        jsr     (a2)
        bne     bem_exit		; oops
        subq.w  #1,d3		; just one
        bne     bem_exbp
*
        move.w  0(a6,a1.l),d2 	; number of bytes to set
        beq.s   bem_clrc		; none, clear characters
        cmp.w   #2,d2		; more than two?
        bgt     bem_exbp		; yes, not reasonable
        beq.s   bem_skln		; exactly two, just skip length
        clr.b   3(a6,a1.l)		; one, clear second
bem_skln
        addq.l  #2,a1		; no, skip length
bem_clrc
        moveq   #2,d2		; always set both characters
        move.w  #pt_stuf1,d1		; first to set is here
        bsr     bem_slnk
        bra     bem_exit
*
        end
